/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: GERA_ETIQUETRAN

Descrio:
Gerao das etiquetas dos servios transportados

P_CDFILIAL     - Codigo da Filial
P_CDSERVFILI   - Codigo do Servio
P_CDDIETPADST  - Codigo da dieta
P_NRSERVTRAN   - Sequencial do servico transportado
P_CDDESTFILI   - Codigo do destino
P_CDCLIENTE    - Codigo do cliente
P_DTSERVTRAN   - Data do Cardpio
P_CDFILAUXPRAT - Chave primria do Prato
P_CDPRATO      - Chave primria do Prato (Cdigo do Prato)
P_QTCONTCOMPST - Quantidade de containers completos
P_QTCONTAIST   - Quantidade do prato por container
P_QTPARCPRATST - Quantidade do prato no ltimo container

Para aplicar e debugar
-- @H:\SISTEMAS\DBA\SQL\ORACLE\7190_PLASTP_GERA_ETIQUETRAN.SQL;
-- @C:\7190_PLASTP_GERA_ETIQUETRAN.SQL;
-- EXECUTE GERA_ETIQUETRAN('9999', '001','XXXX','001', 'J00537053000146','19/11/2001', 'P', '1111010', 0, 100, 10);
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
14/02/2001 - Bruno

*/

CREATE OR REPLACE PROCEDURE GERA_ETIQUETRAN
  (P_CDFILIAL     IN VARCHAR2,
   P_CDSERVFILI   IN VARCHAR2,
   P_CDDIETPADST  IN VARCHAR2,
   P_CDDESTFILI   IN VARCHAR2,
   P_NRSERVTRAN   IN VARCHAR2,
   P_CDCLIENTE    IN VARCHAR2,
   P_DTSERVTRAN   IN DATE,
   P_CDFILAUXPRAT IN VARCHAR2,
   P_CDPRATO      IN VARCHAR2,
   P_QTCONTCOMPST IN NUMBER,
   P_QTCONTAIST   IN NUMBER,
   P_QTCONTINCOST IN NUMBER,
   P_QTPARCPRATST IN NUMBER)
IS
   V_CONTAUXI     NUMBER;
   V_QTCONTINCOST NUMBER;
BEGIN
   DELETE FROM ETIQUETRAN
   WHERE
      CDFILIAL     = P_CDFILIAL     AND
      CDSERVFILI   = P_CDSERVFILI   AND
      CDDESTFILI   = P_CDDESTFILI   AND
      CDCLIENTE    = P_CDCLIENTE    AND
      CDDIETPADST  = P_CDDIETPADST  AND
      DTSERVTRAN   = P_DTSERVTRAN   AND
      CDFILAUXPRAT = P_CDFILAUXPRAT AND
      CDPRATO      = P_CDPRATO      AND
      NRSERVTRAN   = P_NRSERVTRAN;

   V_CONTAUXI := 1;
   WHILE V_CONTAUXI <= P_QTCONTCOMPST
   LOOP
      INSERT INTO ETIQUETRAN
         (CDFILAUXPRAT,
          CDPRATO,
          CDFILIAL,
          CDSERVFILI,
          CDDIETPADST,
          CDDESTFILI,
          CDCLIENTE,
          NRSERVTRAN,
          DTSERVTRAN,
          NRSEQUETIQTR,
          QTPRATETIQTR)
      VALUES
         (P_CDFILAUXPRAT,
          P_CDPRATO,
          P_CDFILIAL,
          P_CDSERVFILI,
          P_CDDIETPADST,
          P_CDDESTFILI,
          P_CDCLIENTE,
          P_NRSERVTRAN,
          P_DTSERVTRAN,
          SUBSTR(TO_CHAR(V_CONTAUXI, '0000'), 2, 4),
          P_QTCONTAIST);
      V_CONTAUXI := V_CONTAUXI + 1;
   END LOOP;

   IF P_QTCONTINCOST > 0 THEN
      V_QTCONTINCOST := P_QTCONTINCOST;
      IF V_CONTAUXI > 1 THEN
         V_QTCONTINCOST := V_QTCONTINCOST + (V_CONTAUXI - 1);
      END IF;
      WHILE V_CONTAUXI <= V_QTCONTINCOST
      LOOP
         INSERT INTO ETIQUETRAN
            (CDFILAUXPRAT,
             CDPRATO,
             CDFILIAL,
             CDSERVFILI,
             CDDIETPADST,
             CDDESTFILI,
             CDCLIENTE,
             NRSERVTRAN,
             DTSERVTRAN,
             NRSEQUETIQTR,
             QTPRATETIQTR)
         VALUES
            (P_CDFILAUXPRAT,
             P_CDPRATO,
             P_CDFILIAL,
             P_CDSERVFILI,
             P_CDDIETPADST,
             P_CDDESTFILI,
             P_CDCLIENTE,
             P_NRSERVTRAN,
             P_DTSERVTRAN,
             SUBSTR(TO_CHAR(V_CONTAUXI, '0000'), 2, 4),
             P_QTPARCPRATST);
         V_CONTAUXI := V_CONTAUXI + 1;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_ETIQUETRAN','4.09.081'); END;
/

