create or replace TRIGGER LOG_SUP_RELACPRODOL
AFTER INSERT OR UPDATE OR DELETE ON RELACPRODOL
FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);  
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
  V_DESC         := '';
  V_ITPESQ       := '';
  V_NMOPERADOR   := '';
  V_IDTIPOOPER   := '';  
  NMUSUARIO(V_NMOPERADOR);
  WEBTUNNING(V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVERRDM,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER);
             
  IF UPDATING THEN
      IF (NVL(:OLD.CDPRODARVOL, 'X') <> NVL(:NEW.CDPRODARVOL, 'X')) THEN
         V_DESC := 'Prod. OL' ||' '|| NVL(:NEW.CDPRODARVOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDPRARVORIG, 'X') <> NVL(:NEW.CDPRARVORIG, 'X')) THEN
         V_DESC := 'Prod. Orig.' ||' '|| NVL(:NEW.CDPRARVORIG,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDMARCA, 'X') <> NVL(:NEW.CDMARCA, 'X')) THEN
         V_DESC := 'Marca' ||' '|| NVL(:NEW.CDMARCA,'') ||'   ';
      END IF;
         
      V_ITPESQ       := :NEW.CDPRODARVOL|| :NEW.CDPRARVORIG|| :NEW.CDMARCA;      
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
        V_DESC   :=        'Prod. OL'             ||' '  || NVL(:NEW.CDPRODARVOL,'')   ||'  '  ||
                           'Prod. Orig.'          ||' '  || NVL(:NEW.CDPRARVORIG,'')   ||'  '  ||
                           'Marca'                ||' '  || NVL(:NEW.CDMARCA,'');

         V_ITPESQ       := :NEW.CDPRODARVOL|| :NEW.CDPRARVORIG|| :NEW.CDMARCA;         
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   :=    'Prod. OL'             ||' '  || NVL(:OLD.CDPRODARVOL,'')   ||'  '  ||
                           'Prod. Orig.'          ||' '  || NVL(:OLD.CDPRARVORIG,'')   ||'  '  ||
                           'Marca'                ||' '  || NVL(:OLD.CDMARCA,'');

            V_ITPESQ         := :OLD.CDPRODARVOL|| :OLD.CDPRARVORIG|| :OLD.CDMARCA;            
            V_IDTIPOOPER     := '3';
         END IF;
      END IF;
   END IF;
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 400);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER)
      VALUES
         ('RELACPRODOL',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_RELACPRODOL','5.67.XXX'); END;
/
